{ $HDR$}
{**********************************************************************}
{ Unit archived using Team Coherence }
{ Team Coherence is Copyright 2001 by Quality Software Components }
{ }
{ For further information / comments, visit our WEB site at }
{ http://www.TeamCoherence.com }
{**********************************************************************}
{}
{ $Log: 10065: CAL.pas 
{
{ Rev 1.0 2001/12/24 U 05:53:06 levi Version: 2.0.0.0
}
{
{ Rev 1.0 2001/12/24 U 05:53:06 levi
{ ƶ 睊ثe1.2.0.1
}
{* =================================Blue Fox================================= *}
{*   W ١Gcal 
{*    G2001/1/24
{*   s @G^
{* =================================Blue Fox================================= *}
{*    סG
{*  & ~GoഫPAXӬ@
{*
{*    ơG
{*
{*  s  G
{*
{* =================================Blue Fox================================= *}
{* nıoѪAѬOH᪺AΧOHݪAЫOѪ *}
{* =======================================================================2.0 *}
{* `ѻG *}
{* 1. b{ԭz[J` 榡 *}
{* // @ {v, ק,u@Ҧ, קyz *}
{* Ҧp // @levi,01/12/21,Add,oC *} 
{* Ӥu@Ҧ Add,A sWԭz ; *} 
{* Edit,E ק¦ԭz; *} 
{* Make,M RNԭzRӬOܬ`; *} 
{* O 䥦bWҦ; *} 
{* 2. bŧi{Ǫ襲[J{Ǫ\໡ // `ѲŸC *} 
{* ========================================================================== *}
//HU»
{
PAXӬ@. (Delpi 3.0 βե)
(d : @~ܥ@ʦ~)

sW Property :
LYear : A䤧~
LMonth : A䤧(tƬ|)
LDay : A䤧Ѽ
LYearName : A䤧QҤlW(readonly)

@: ^
E-Mail : rexpeng@ms1.hinet.net

 FreeWare, iۥѴ, qO䧹, pBugE-Mail,
pzn]E-Mail@. OK! :)
}
unit cal;

interface

uses Classes, Controls, Messages, Windows, Forms, Graphics, StdCtrls,
Grids, SysUtils, Lunar;

type
TDayOfWeek = 0..6;

TRexCalendar = class(TCustomGrid)
private
FDate: TDateTime;
FMonthOffset: Integer;
FOnChange: TNotifyEvent;
FReadOnly: Boolean;
FStartOfWeek: TDayOfWeek;
FUpdating: Boolean;
FUseCurrentDate: Boolean;
FLYear: integer;
FLMonth: Integer;
FLDay: Integer;
FLYearName : String;
function GetCellText(ACol, ARow: Integer): string;
function GetDateElement(Index: Integer): Integer;
procedure SetCalendarDate(Value: TDateTime);
procedure SetDateElement(Index: Integer; Value: Integer);
procedure SetStartOfWeek(Value: TDayOfWeek);
procedure SetUseCurrentDate(Value: Boolean);
procedure SetLDay(Value : Integer);
function GetLDay: Integer;
procedure SetLMonth(Value: Integer);
function GetLMonth : Integer;
procedure SetLYear(Value: Integer);
function GetLYear : Integer;
function StoreCalendarDate: Boolean;
function GetLYearName : string;
function GToL(y, m , d: integer) : string;
protected
procedure Change; dynamic;
procedure ChangeMonth(Delta: Integer);
procedure Click; override;
function DaysPerMonth(AYear, AMonth: Integer): Integer; virtual;
function DaysThisMonth: Integer; virtual;
procedure DrawCell(ACol, ARow: Longint; ARect: TRect; AState: TGridDrawState); override;
function IsLeapYear(AYear: Integer): Boolean; virtual;
function SelectCell(ACol, ARow: Longint): Boolean; override;
procedure WMSize(var Message: TWMSize); message WM_SIZE;
public
constructor Create(AOwner: TComponent); override;
property CalendarDate: TDateTime read FDate write SetCalendarDate stored StoreCalendarDate;
property CellText[ACol, ARow: Integer]: string read GetCellText;
procedure NextMonth;
procedure NextYear;
procedure PrevMonth;
procedure PrevYear;
procedure UpdateCalendar; virtual;
published
property Align;
property BorderStyle;
property Color;
property Ctl3D;
property Day: Integer index 3 read GetDateElement write SetDateElement stored False;
property LDay: integer read GetLDay write SetLDay;
property LYearName : string read GetLYearName;
property Enabled;
property Font;
property GridLineWidth;
property Month: Integer index 2 read GetDateElement write SetDateElement stored False;
property LMonth: Integer read GetLMonth write SetLMonth;
property ParentColor;
property ParentFont;
property ParentShowHint;
property PopupMenu;
property ReadOnly: Boolean read FReadOnly write FReadOnly default False;
property ShowHint;
property StartOfWeek: TDayOfWeek read FStartOfWeek write SetStartOfWeek;
property TabOrder;
property TabStop;
property UseCurrentDate: Boolean read FUseCurrentDate write SetUseCurrentDate default True;
property Visible;
property Year: Integer index 1 read GetDateElement write SetDateElement stored False;
property LYear: integer read GetLYear write SetLYear;
property OnClick;
property OnChange: TNotifyEvent read FOnChange write FOnChange;
property OnDblClick;
property OnDragDrop;
property OnDragOver;
property OnEndDrag;
property OnEnter;
property OnExit;
property OnKeyDown;
property OnKeyPress;
property OnKeyUp;
property OnStartDrag;
end;

procedure Register;

implementation

constructor TRexCalendar.Create(AOwner: TComponent);
var
AYear, AMonth, ADay : Word;
//daterec : Tdaterec;
begin
inherited Create(AOwner);
{ defaults }
FUseCurrentDate := True;
FixedCols := 0;
FixedRows := 1;
ColCount := 7;
RowCount := 7;
ScrollBars := ssNone;
Options := Options - [goRangeSelect] + [goDrawFocusSelected];
Font.Name := 'ө';
Font.Size := 12;
FDate := Date;
decodedate(FDate, AYear, AMonth, ADay);
{daterec.GregYear := AYear;
daterec.wMonth := AMonth;
daterec.wDay := ADay;
if GregorianToLunarDate(@daterec) then begin
FLYear := LunarYearName(daterec.LunarYear);
FLMonth := daterec.wMonth;
FLDay := daterec.wDay;
end;}
Solar2Lunar(AYear-1911, AMonth, ADay, FLYear, FLMonth, FLDay);
UpdateCalendar;
end;

procedure TRexCalendar.Change;
begin
if Assigned(FOnChange) then FOnChange(Self);
end;

function CutStr(const str : string) : integer;
var
i : integer;
begin
for i := 1 to length(str) do
if str[i] > #127 then
break;
result := i;
end;

procedure TRexCalendar.Click;
var
TheCellText: string;
P: integer;
begin
inherited Click;
TheCellText := CellText[Col, Row];
P := CutStr(TheCellText);
TheCellText := Copy(TheCellText, 1, P-1);
if TheCellText <> '' then Day := StrToInt(TheCellText);
end;

function TRexCalendar.IsLeapYear(AYear: Integer): Boolean;
begin
Result := (AYear mod 4 = 0) and ((AYear mod 100 <> 0) or (AYear mod 400 = 0));
end;

function TRexCalendar.DaysPerMonth(AYear, AMonth: Integer): Integer;
const
DaysInMonth: array[1..12] of Integer = (31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31);
begin
Result := DaysInMonth[AMonth];
if (AMonth = 2) and IsLeapYear(AYear) then Inc(Result); { leap-year Feb is special }
end;

function TRexCalendar.DaysThisMonth: Integer;
begin
Result := DaysPerMonth(Year, Month);
end;

procedure TRexCalendar.DrawCell(ACol, ARow: Longint; ARect: TRect; AState: TGridDrawState);
var
LText: string;
TheText: string;
P, fs : integer;
cl : TColor;
begin
TheText := CellText[ACol, ARow];
if ARow <> 0 then begin
P := CutStr(TheText);
LText := copy(Thetext, P, Length(TheText)-P+1);
TheText := Copy(TheText, 1, P-1);
end;
cl := Canvas.Font.Color;
if ACol = ((7-FStartOfWeek) mod 7) then
Canvas.Font.Color := clRed
else
Canvas.Font.Color := cl;
with ARect, Canvas do begin
if ARow = 0 then begin
TextRect(ARect, Left + (Right - Left - TextWidth(TheText)) div 2,
Top + (Bottom - Top - TextHeight(TheText)) div 2, TheText);
end else begin
fs := Font.Size;
TextOut(Left + 2, Top + 2, TheText);
Font.Size := fs div 2;
TextOut(Right-TextWidth(LText)-2, Bottom-TextHeight(LText)-2, LText);
Font.Size := fs;
end;
end;
end;

function TRexCalendar.GToL(y, m, d : integer): string;
const
LDayName : array[1..30] of string = ('@', 'G', 'T', '|', '줭', '줻', 'C', 'K', 'E', 'Q',
'Q@', 'QG', 'QT', 'Q|', 'Q', 'Q', 'QC', 'QK', 'QE', 'GQ',
'ܤ@', 'ܤG', 'ܤT', 'ܥ|', 'ܤ', 'ܤ', 'ܤC', 'ܤK', 'ܤE', 'TQ');
LMonthName : array[1..12] of string = ('', 'G', 'T', '|', '', '', 'C', 'K', 'E', 'Q', 'Q@', 'QG');
var
//daterec : TDaterec;
ly, lm, ld : integer;
begin
//daterec.GregYear := y;
//daterec.wMonth := m;
//daterec.wDay := d;
Solar2Lunar(y-1911, m, d, ly, lm, ld);
//if GregorianToLunarDate(@daterec) then begin
if ld = 1 then begin
if lm < 0 then
result := '|';
result := result + LMonthName[abs(lm)]
end else
result := LDayName[ld];
//end;
end;

function TRexCalendar.GetCellText(ACol, ARow: Integer): string;
var
DayNum: Integer;
begin
if ARow = 0 then { day names at tops of columns }
Result := ShortDayNames[(StartOfWeek + ACol) mod 7 + 1]
else
begin
DayNum := FMonthOffset + ACol + (ARow - 1) * 7;
if (DayNum < 1) or (DayNum > DaysThisMonth) then Result := ''
else Result := IntToStr(DayNum)+GToL(year, month, DayNum);
end;
end;

function TRexCalendar.SelectCell(ACol, ARow: Longint): Boolean;
begin
if ((not FUpdating) and FReadOnly) or (CellText[ACol, ARow] = '') then
Result := False
else Result := inherited SelectCell(ACol, ARow);
end;

{function DaysPerLunarMonth(GYear, LYear, AMonth: Integer): Integer;
var
daterec: TDateRec;
begin
daterec.GregYear := GYear;
daterec.LunarYear := LYear;
daterec.wMonth := AMonth;
daterec.wDay := 0;
Result := DaysInLunarMonth(@daterec);
end;}

function TRexCalendar.GetLYearName : string;
begin
result := YearName(FLYear);
end;

procedure TRexCalendar.SetLDay(Value: integer);
var
//daterec : Tdaterec;
sy, sm, sd : integer;
begin
if Value > DaysPerLunarMonth(FLyear, FLMonth) then
exit
else
FLDay := Value;
//FDate := EncodeLunarDate(Year, LunarYearNameToNumeric(FLYear), FLMonth, FLDay);
{daterec.GregYear := Year;
daterec.LunarYear := LunarYearNameToNumeric(FLYear);
daterec.wMonth := FLMonth;
daterec.wDay := FLDay;
if LunarToGregorianDate(@daterec) then
FDate := EncodeDate(daterec.GregYear, daterec.wMonth, daterec.wDay);
}
Lunar2Solar(FLYear, FLMonth, FLDay, SY, SM, SD);
FDate := StrToDate(Format('%.4d/%.2d/%.2d', [sy+1911, sm, sd]));
UpdateCalendar;
Change;
end;

function TRexCalendar.GetLDay: integer;
var
//daterec : Tdaterec;
AYear, AMonth, ADay : Word;
begin
DecodeDate(FDate, AYear, AMonth, ADay);
//DecodeLunarDate(FDate, LY, LM, LD);
{daterec.GregYear := AYear;
daterec.wMonth := AMonth;
daterec.wDay := ADay;
if GregorianToLunarDate(@daterec) then begin
result := daterec.wDay;
FLYear := LunarYearName(daterec.LunarYear);
end;}
Solar2Lunar(AYear-1911, AMonth, ADay, FLYear, FLMonth, FLDay);
result := FLDay;
end;

procedure TRexCalendar.SetLMonth(Value: Integer);
var
//daterec : Tdaterec;
sy, sm, sd : integer;
begin
if Value > 12 then exit else FLMonth := Value;
//FDate := EncodeLunarDate(Year, LunarYearNameToNumeric(FLYear), FLMonth, FLDay);
{daterec.GregYear := Year;
daterec.LunarYear := LunarYearNameToNumeric(FLYear);
daterec.wMonth := FLMonth;
daterec.wDay := FLDay;
if LunarToGregorianDate(@daterec) then
FDate := EncodeDate(daterec.GregYear, daterec.wMonth, daterec.wDay);}
Lunar2Solar(FLYear, FLMonth, FLDay, SY, SM, SD);
FDate := StrToDate(Format('%.4d/%.2d/%.2d', [sy+1911, sm, sd]));
UpdateCalendar;
Change;
end;

function TRexCalendar.GetLMonth: Integer;
var
//daterec : Tdaterec;
AYear, AMonth, ADay : Word;
begin
DecodeDate(FDate, AYear, AMonth, ADay);
//DecodeLunarDate(FDate, LY, LM, LD);
{daterec.GregYear := AYear;
daterec.wMonth := AMonth;
daterec.wDay := ADay;
if GregorianToLunarDate(@daterec) then begin
result := daterec.wMonth;
FLYear := LunarYearName(daterec.LunarYear);
end;}
Solar2Lunar(AYear-1911, AMonth, ADay, FLYear, FLMonth, FLDay);
result := FLMonth;
end;

procedure TRexCalendar.SetLYear(Value: Integer);
var
//daterec : Tdaterec;
sy, sm, sd : integer;
begin
if (Value > 100) and (Value < 1) then exit else FLYear := Value;
//FDate := EncodeLunarDate(Year, LunarYearNameToNumeric(FLYear), FLMonth, FLDay);
{daterec.GregYear := Year;
daterec.LunarYear := LunarYearNameToNumeric(FLYear);
daterec.wMonth := FLMonth;
daterec.wDay := FLDay;
if LunarToGregorianDate(@daterec) then
FDate := EncodeDate(daterec.GregYear, daterec.wMonth, daterec.wDay);}
Lunar2Solar(FLYear, FLMonth, FLDay, SY, SM, SD);
FDate := StrToDate(Format('%.4d/%.2d/%.2d', [sy+1911, sm, sd]));
UpdateCalendar;
Change;
end;

function TRexCalendar.GetLYear: Integer;
var
//daterec : Tdaterec;
AYear, AMonth, ADay : Word;
begin
DecodeDate(FDate, AYear, AMonth, ADay);
//DecodeLunarDate(FDate, LY, LM, LD);
{daterec.GregYear := AYear;
daterec.wMonth := AMonth;
daterec.wDay := ADay;
if GregorianToLunarDate(@daterec) then begin
result := daterec.wMonth;
FLYear := LunarYearName(daterec.LunarYear);
end;}
Solar2Lunar(AYear-1911, AMonth, ADay, FLYear, FLMonth, FLDay);
result := FLYear;
end;

procedure TRexCalendar.SetCalendarDate(Value: TDateTime);
var
AYear, AMonth, ADay : Word;
//daterec : TDateRec;
begin
FDate := Value;
DecodeDate(FDate, AYear, AMonth, ADay);
{daterec.GregYear := AYear;
daterec.wMonth := AMonth;
daterec.wDay := ADay;
if GregorianToLunarDate(@daterec) then begin
FLYear := LunarYearName(daterec.LunarYear);
FLMonth := daterec.wMonth;
FLDay := daterec.wDay;
end;}
Solar2Lunar(AYear-1911, AMonth, ADay, FLYear, FLMonth, FLDay);
UpdateCalendar;
Change;
end;

function TRexCalendar.StoreCalendarDate: Boolean;
begin
Result := not FUseCurrentDate;
end;

function TRexCalendar.GetDateElement(Index: Integer): Integer;
var
AYear, AMonth, ADay: Word;
begin
DecodeDate(FDate, AYear, AMonth, ADay);
case Index of
1: Result := AYear;
2: Result := AMonth;
3: Result := ADay;
else Result := -1;
end;
end;

procedure TRexCalendar.SetDateElement(Index: Integer; Value: Integer);
var
AYear, AMonth, ADay: Word;
begin
if Value > 0 then
begin
DecodeDate(FDate, AYear, AMonth, ADay);
case Index of
1: if AYear <> Value then AYear := Value else Exit;
2: if (Value <= 12) and (Value <> AMonth) then AMonth := Value else Exit;
3: if (Value <= DaysThisMonth) and (Value <> ADay) then ADay := Value else Exit;
else Exit;
end;
FDate := EncodeDate(AYear, AMonth, ADay);
FUseCurrentDate := False;
UpdateCalendar;
Change;
end;
end;

procedure TRexCalendar.SetStartOfWeek(Value: TDayOfWeek);
begin
if Value <> FStartOfWeek then
begin
FStartOfWeek := Value;
UpdateCalendar;
end;
end;

procedure TRexCalendar.SetUseCurrentDate(Value: Boolean);
begin
if Value <> FUseCurrentDate then
begin
FUseCurrentDate := Value;
if Value then
begin
FDate := Date; { use the current date, then }
UpdateCalendar;
end;
end;
end;

{ Given a value of 1 or -1, moves to Next or Prev month accordingly }
procedure TRexCalendar.ChangeMonth(Delta: Integer);
var
AYear, AMonth, ADay: Word;
NewDate: TDateTime;
CurDay: Integer;
begin
DecodeDate(FDate, AYear, AMonth, ADay);
CurDay := ADay;
if Delta > 0 then ADay := DaysPerMonth(AYear, AMonth)
else ADay := 1;
NewDate := EncodeDate(AYear, AMonth, ADay);
NewDate := NewDate + Delta;
DecodeDate(NewDate, AYear, AMonth, ADay);
if DaysPerMonth(AYear, AMonth) > CurDay then ADay := CurDay
else ADay := DaysPerMonth(AYear, AMonth);
CalendarDate := EncodeDate(AYear, AMonth, ADay);
end;

procedure TRexCalendar.PrevMonth;
begin
ChangeMonth(-1);
end;

procedure TRexCalendar.NextMonth;
begin
ChangeMonth(1);
end;

procedure TRexCalendar.NextYear;
begin
if IsLeapYear(Year) and (Month = 2) and (Day = 29) then Day := 28;
Year := Year + 1;
end;

procedure TRexCalendar.PrevYear;
begin
if IsLeapYear(Year) and (Month = 2) and (Day = 29) then Day := 28;
Year := Year - 1;
end;

procedure TRexCalendar.UpdateCalendar;
var
AYear, AMonth, ADay: Word;
FirstDate: TDateTime;
begin
FUpdating := True;
try
DecodeDate(FDate, AYear, AMonth, ADay);
FirstDate := EncodeDate(AYear, AMonth, 1);
FMonthOffset := 2 - ((DayOfWeek(FirstDate) - StartOfWeek + 7) mod 7); { day of week for 1st of month }
if FMonthOffset = 2 then FMonthOffset := -5;
MoveColRow((ADay - FMonthOffset) mod 7, (ADay - FMonthOffset) div 7 + 1,
False, False);
Invalidate;
finally
FUpdating := False;
end;
end;

procedure TRexCalendar.WMSize(var Message: TWMSize);
var
GridLines: Integer;
begin
GridLines := 6 * GridLineWidth;
DefaultColWidth := (Message.Width - GridLines) div 7;
DefaultRowHeight := (Message.Height - GridLines) div 7;
end;

procedure Register;
begin
RegisterComponents('Flyup', [TRexCalendar]);
end;

end.

